This project is a component of the *Experimental Physics and Industrial
Control System* (`EPICS`_), a set of tools, libraries and applications
developed collaboratively and used worldwide to create distributed soft
real-time control systems for large scale scientific instruments.

The *State Notation Language* (SNL), is a `domain specific programming
language`_ that smoothly integrates with and depends and builds on EPICS
`base`_. This project defines SNL and provides an implementation, consisting
of the SNL compiler and runtime system.

The Sequencer is `free software`_, licensed under the `EPICS Open License`_.

For further information

* take a look at the :ref:`Overview` to get a first impression of the
  Sequencer's features.

* This `talk about version 2.1 of the Sequencer`_ contains a short
  introduction to SNL, including a walk through a simple example program to
  illustrate the basic concepts.

* A (slightly out-dated) :doc:`Tutorial` is also available,

* as well as a detailed :doc:`Reference`,

* and instructions for download and :doc:`Installation`.

* All of these are part of the :doc:`Manual`.

.. _domain specific programming language: http://en.wikipedia.org/wiki/Domain-specific_programming_language
.. _EPICS: http://www.aps.anl.gov/epics/
.. _base: http://www.aps.anl.gov/epics/base/index.php
.. _talk about version 2.1 of the Sequencer: http://www-csr.bessy.de/control/SoftDist/sequencer/talks/epics-meeting-2011-PSI/sequencer-2-1-slides.pdf
.. _free software: http://www.gnu.org/philosophy/free-sw.html
.. _EPICS Open License: http://www.aps.anl.gov/epics/license/open.php
